<!doctype html>
<html lang="en">

  <head>
    <meta charset="utf-8">

    <title>C++14 - The Top 10</title>

    <meta name="description" content="A framework for easily creating beautiful presentations using HTML">
    <meta name="author" content="Hakim El Hattab">

    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">

    <link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/theme/moon.css" id="theme">

    <!-- Code syntax highlighting -->
    <!-- <link rel="stylesheet" href="lib/css/zenburn.css"> -->

    <!-- Printing and PDF exports -->
    <script>
      var link = document.createElement( 'link' );
      link.rel = 'stylesheet';
      link.type = 'text/css';
      link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
      document.getElementsByTagName( 'head' )[0].appendChild( link );
    </script>

    <!--[if lt IE 9]>
    <script src="lib/js/html5shiv.js"></script>
    <![endif]-->
  </head>

  <body>

    <div class="reveal">

      <!-- Any section element inside of this container is displayed as a slide -->
      <div class="slides">
        <section>
          <h1>Top 10 C++14 Features</h1>
          <h3>Out Now!</h3>
          <p>
            <small>Slides by <a href="mailto:kircher@otris.de">Ben</a> /
                Code samples by <a href="http://coliru.stacked-crooked.com/">Coliru</a> /
                Layout by <a href="http://lab.hakim.se/reveal-js/#/">reveal.js</a>
            </small>
          </p>
        </section>

        <section>
            <p>Every example that follows compiles with
            <ul>
              <li>Visual Studio 2012</li>
              <li>gcc 4.8</li>
            </ul>
            </p>
        </section>

        <section>
          <h2>Ahhh, time is running so fast</h2>
          <table>
            <thead>
              <tr>
                <th>C++11</th>
                <th>C++14</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td><em>Lots of new stuff</em></td>
                <td><em>Only minor corrections</em></td>
              </tr>
              <tr>
                <td>unique_ptr, shared_ptr</td>
                <td>make_unique&lt;T&gt;()</td>
              </tr>
              <tr>
                <td>lambdas</td>
                <td>polymorphic lambdas</td>
              </tr>
            </tbody>
          </table>
        </section>

        <section>
          <h2>Shiny New Things</h2>
          <ol>
            <li>auto specifier</li>
            <li>initializer lists</li>
            <li>range based for-loops</li>
            <li>lambdas</li>
            <li>unique_ptr</li>
            <li>shared_ptr</li>
            <li>unordered_map</li>
            <li>control of defaults: default and delete</li>
            <li>raw string literals</li>
            <li>nullptr</li>
          </ol>
        </section>

        <section>
          <h2>0. My favourite</h2>
        </section>

        <section>
          <h2>0.My favourite: right-angle brackets!</h2>
          <p>&gt;&gt; illegal in C++98</p>
          <pre><code class="cpp" data-trim contenteditable>
int main()
{
    std::vector&lt;std::vector&lt;std::string&gt; &gt; vec;

    // Now you can write:
    std::vector&lt;std::vector&lt;std::string&gt;&gt; vec2;
}
          </code></pre>
        </section>

        <section>
          <h2>1. auto specifier</h2>
        </section>

        <section>
          <h2>1. auto specifier</h2>
          <p>All about type inference</p>
          <pre>
          <tt>
            Syntax:
            auto <em>variable initializer</em>
            auto <em>function -&gt; return type</em>
          </tt>
          </pre>
        </section>

        <section>
          <h2>1. auto specifier</h2>
          <p><small>Specifies that the type of the variable that is being
              declared will be automatically deduced from its
              initializer.</small></p>
          <pre><code class="cpp" data-trim contenteditable>
auto i = 42;
auto u = 1729U;
auto str = std::string("Mehr Bier");
          </code></pre>
        </section>

        <section>
          <h2>1. auto specifier - why should I use it?</h2>
          <p>If you are lazy</p>
          <pre><code class="cpp" data-trim contenteditable>
struct Beer
{
    Beer(const char* s) : name(s) {}

    std::string name;
};

int main()
{
    std::vector&lt;Beer&gt; vec{ "Thier", "Bergmann", "Kronen" };

    for (std::vector&lt;Beer&gt;::iterator it = vec.begin(); it != vec.end(); ++it)
    {
        std::cout &lt;&lt; it-&gt;name &lt;&lt; "-Pils\n";
    }
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/a7d3de35da9e15a2">Edit & run</a></small></p>
        </section>

        <section>
          <h2>1. auto specifier - why should I use it?</h2>
          <p>
            If you want to <strong>avoid bugs</strong>
          </p>
          <pre><code class="cpp">
char buf[20];
std::istringstream stream("Hello, there!");
stream.read(buf, sizeof buf);
// Conversion from std::streamsize to size_t
size_t bytes_extracted = stream.gcount();
std::cout &lt;&lt; "Characters extracted " &lt;&lt; bytes_extracted &lt;&lt; '\n';
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/5dc2185fc4e12fb1">Edit & run</a></small></p>
        </section>

        <section>
          <h2>1. auto specifier</h2>
          <pre><code class="cpp" data-trim contenteditable>
template&lt;class T, class U&gt;
auto add(T t, U u) -&gt; decltype(t + u)
{
  return t + u;
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/6f34b82dc7e83bec">Edit & run</a></small></p>
        </section>

        <section>
            <h2>2. initializer lists</h2>
        </section>

        <section>
            <h2>2. initializer lists</h2>
            <p>All about uniform initialization</p>
            <p>{ }</p>
        </section>

        <section>
          <h2>2. initializer lists</h2>
          <pre><code class="cpp">
#include &lt;iostream&gt;
#include &lt;string&gt;
#include &lt;vector&gt;
#include &lt;unordered_map&gt;

int main()
{
    std::vector&lt;double&gt; vec{ 1, 2, 3.456, 99.99 };
    std::unordered_map&lt;std::string, std::string&gt; beers{
        {"Thier","Dortmund"},
        {"Krombacher","Kreuztal"},
        {"Fiege","Bochum"}
    };
    for (const auto&amp; beer : beers)
        std::cout &lt;&lt; beer.first &lt;&lt; ", " &lt;&lt; beer.second &lt;&lt; std::endl;
}
            </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/ccd1cab7264ae516">Edit & run</a></small></p>
          <p><small>Supported since November 2012 CTP</small></p>
        </section>
        <section>
          <h2>2. initializer lists - implement this ourselves</h2>
          <pre><code class="cpp">
#include &lt;initializer_list&gt;

template&lt;class T&gt; class ListJ
{
public:
    // initializer-list constructor
    ListJ (std::initializer_list&lt;T&gt; s)
    {
        // get the right amount of space
        reserve(s.size());

        // initialize elements
        uninitialized_copy(s.begin(), s.end(), elem);

        // set size
        sz = s.size();
    }

    // ...
};
          </code></pre>
        </section>

        <section>
          <h2>3. range-for statement</h2>
        </section>

        <section>
          <h2>3. range-for statement</h2>
          <p>Iterate through a <em>range</em></p>
          <p>which is anything with a begin() and end()
          <p> or with a begin() and length</p>
        </section>

        <section>
          <h2>3. range-for statement</h2>
          <pre><code class="cpp">
int main()
{
    std::vector&lt;std::string&gt; vec{"Bergmann", "Union Export", "Fiege"};
    for (auto&amp; beer : vec) // access as reference to change a value
    {
        std::for_each(begin(beer), end(beer),
            [](char&amp; c) { c = std::toupper(c); });
    }
    // access as const-ref to avoid copying
    for (const auto&amp; beer : vec) std::cout &lt;&lt; beer &lt;&lt; '\n';
    for (auto x : { 11,22,33,44,55,66,77 }) std::cout &lt;&lt; x &lt;&lt; '\n';
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/eb03777a0557d4a3">Edit & run</a></small></p>
        </section>

        <section>
          <h2>4. lambda expressions</h2>
        </section>

        <section>
          <h2>4. lambda expressions</h2>
          <p>An anonymous function (a function without a name, thats all)</p>
          <p>Can have an optional capture clause (that makes it a closure)</p>
          <pre>
          <tt>
            Syntax:
            [<em>capture-list</em>] (<em>params</em>) {<em>body</em>}
            [<em>capture-list</em>] {<em>body</em>}
            [<em>capture-list</em>] (<em>params</em>) <em>-&gt; ret</em> {<em>body</em>}
            [<em>capture-list</em>] (<em>params</em>) mutable {<em>body</em>}
          </tt>
          </pre>
        </section>

        <section>
          <h2>4. lambda expressions</h2>
          <pre><code class="cpp">
int main()
{
    std::vector&lt;int&gt; vec{ 1,2,3,4,5,6,7 };
    int x = 4;
    vec.erase(std::remove_if(vec.begin(), vec.end(),
            [x](int n) { return n &lt; x; } ), vec.end());

    std::cout &lt;&lt; "vec: ";
    for (auto i: vec) {
        std::cout &lt;&lt; i &lt;&lt; ' ';
    }
    std::cout &lt;&lt; '\n';
    // The type of a closure cannot be named, but can
    // be inferred with auto
    auto add4 = [](int i) { return i+4; };
    std::cout &lt;&lt; "add4: " &lt;&lt; add4(6) &lt;&lt; '\n';
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/92f6fb14aafe331d">Edit & run</a></small></p>
        </section>

        <section>
          <h2>4. lambda expressions - capturing explained</h2>
          <p><small>Access variables from outer scope (and optionally modify them)</small></p>
          <pre><code class="cpp">
#include &lt;vector&gt;
#include &lt;iostream&gt;
#include &lt;string&gt;

int main()
{
    std::vector&lt;std::string&gt; vec{ "Dortmunder Actien-Brauerei" };
    auto push_to_vec = [](const std::string&amp; beer)
    {
        vec.push_back(beer);
    };
    for (const auto&amp; b : { "Hansa", "Bergmann", "Thier" })
    {
        push_to_vec(b);
    }
    for (const auto&amp; b : vec) std::cout &lt;&lt; b &lt;&lt; '\n';
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/4c31095d06bbceef">Edit & run</a></small></p>
        </section>

        <section>
          <h2>4. lambda expressions - capturing explained</h2>
          <pre>
          <tt>
          capture-list:
          [a,&amp;b] a is captured by value, b is captured by ref
          [this] captures this pointer by value
          [&amp;] captures all variables used in body of lambda by ref
          [=] captures all variables used in body of lambda by value
          [] captures nothing
          </tt>
          </pre>
        </section>

        <section>
          <h2>That's it with the language for today</h2>
          <p>Now on to the quest on getting rid of owning raw-pointers:
          <br>
          <b>Smart pointers!</b></p>
          <pre><code class="cpp">
          new, delete
          new[], delete[]
          </code></pre>
        </section>

        <section>
          <h2>5. unique_ptr&lt;T&gt;</h2>
        </section>

        <section>
          <h2>5. unique_ptr&lt;T&gt;</h2>
          <ul>
            <li>Replacement for auto_ptr, which is now deprecated</li>
            <li>Is movable, not copyable</li>
            <li><em>(Thanks to rvalue-references and move-semantics)</em></li>
            <li>You can put it into a vector</li>
            <li>Helps immensely writing exception-safe code</li>
            <li>Nearly no performance overhead</li>
          </ul>
        </section>

        <section>
          <h2>5. unique_ptr&lt;T&gt;</h2>
          <pre><code class="cpp">
#include &lt;memory&gt;

struct Foo
{
    Foo() { std::cout &lt;&lt; "Foo::Foo\n";  }
};

int main()
{
    std::unique_ptr&lt;Foo&gt; p1(new Foo);  // p1 owns Foo

    // Foo instance is destroyed when p1 goes out of scope
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/07b272bb3a395806">Edit & run</a></small></p>
        </section>

        <section>
          <h2>6. shared_ptr&lt;T&gt;</h2>
        </section>

        <section>
          <h2>6. shared_ptr&lt;T&gt;</h2>
          <ul>
            <li>Reference-counting smart pointer</li>
            <li>Shared ownership</li>
            <li>Object is deleted when last reference to it goes out of scope</li>
            <li>Little performance overhead, mitigated with make_unique</li>
          </ul>
        </section>

        <section>
          <h2>6. shared_ptr&lt;T&gt;</h2>
          <pre><code class="cpp">
#include &lt;memory&gt;

int main()
{
    {
        std::shared_ptr&lt;int&gt; p1(new int); // count is 1
        {
            std::shared_ptr&lt;int&gt; p2(p1); // count is 2
            {
                std::shared_ptr&lt;int&gt; p3(p1); // count is 3
            } // count goes back down to 2
        } // count goes back down to 1
    } // here the count goes to 0 and the int is deleted.
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/95a25bf7e3ca498a">Edit & run</a></small></p>
        </section>

        <section>
          <h2>7. unordered_map&lt;T&gt;</h2>
          <p>Hash tables, yeah :/</p>
          <pre><code class="cpp">
#include &lt;unordered_map&gt;
          </code></pre>
        </section>

        <section>
          <h2>7. unordered_map&lt;T&gt;</h2>
          <pre><code class="cpp">
template&lt;
    class Key,
    class T,
    class Hash = std::hash&lt;Key&gt;,
    class KeyEqual = std::equal_to&lt;Key&gt;,
    class Allocator = std::allocator&lt; std::pair&lt;const Key, T&gt; &gt;
&gt; class unordered_map;
          </code></pre>
        </section>

        <section>
          <h2>7. unordered_map&lt;T&gt;</h2>
          <ul>
            <li>K -&gt; V</li>
            <li>associative container</li>
            <li>contains key-value pairs with unique keys</li>
            <li>much like std::map but not sorted, values kept in buckets</li>
            <li>usually yields much faster look-up than std::map</li>
          </ul>
        </section>

        <section>
          <h2>8. = default and = delete</h2>
          <p>Control of defaults</p>
        </section>

        <section>
          <h2>8. = default and = delete</h2>
          <p>Remember?</p>
          <pre><code class="cpp">
class Foo
{
public:
    // ...

private:
    // Never defined
    Foo(const Foo&amp;);
    Foo&amp; operator=(const Foo&amp;);
};
          </code></pre>
        </section>

        <section>
          <h2>8. = default and = delete</h2>
          <p>Now you can just write:</p>
          <pre><code class="cpp">
class Foo
{
public:
    Foo(const Foo&amp;) = delete;
    Foo&amp; operator=(const Foo&amp;) = delete;

    // ...
};
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/fe78f5aeb326cc66">Edit & run</a></small></p>
        </section>

        <section>
          <h2>8. = default and = delete</h2>
          <p>We can delete an undesired conversion like this:</p>
          <pre><code>
struct Foo
{
    // ...
    Foo(long long); // can initialize with an long long
    Foo(long) = delete; // but not anything less!
};
          </code></pre>
        </section>

        <section>
          <h2>9. Raw string literals</h2>
          <pre><code>
const char* str = R"("quoted string")";
// the string is "quoted string"
          </code></pre>
        </section>

        <section>
          <h2>9. Raw string literals</h2>
          <p>Very useful if you have inline SQL or regexp.</p>
          <p>Motivating example:</p>
          <pre><code>
#include &lt;iostream&gt;
#include &lt;regex&gt;

int main()
{
    const char* pat = R"((\+|-)?[[:digit:]]+)";
    std::regex integer_pattern(pat);
    const char* input = "-123";
    std::cout &lt;&lt; (std::regex_match(input, integer_pattern) ?
        "matches" : "does not match") &lt;&lt; std::endl;
}
          </code></pre>
          <p><a href="http://coliru.stacked-crooked.com/a/8ace0b58bfd1ed11">Edit & run</a></p>
        </section>

        <section>
          <h2>10. Last but not least: nullptr</h2>
        </section>

        <section>
          <h2>10. nullptr</h2>
          <p>A null pointer literal</p>
          <p>Yes, it has a <strong>type</strong>: std::nullptr_t</p>
        </section>

        <section>
          <h2>10. nullptr</h2>
          <p></p>
          <p>Contrary:</p>
          <pre><code>
#define NULL 0
          </code></pre>
          <p><small>Actually, implementation defined, but pretty
            likely</small></p>
        </section>

        <section>
          <h2>10. nullptr</h2>
          <pre><code>
void f(int* pi) { }

void f(double* pd) { }

void f(std::nullptr_t nullp) { }

int main()
{
    int* pi; double* pd;

    f(pi);
    f(pd);
    f(nullptr);  // would be ambiguous without void f(nullptr_t)
    // f(NULL);  // ambiguous overload
}
          </code></pre>
          <p><small><a href="http://coliru.stacked-crooked.com/a/afe2438ee1866663">Edit & run</a></small></p>
        </section>

        <section>
          <h2>10. nullptr</h2>
          <p>Pretty easy to transform your code base, too ;)</p>
          <p>$ sed -i `s/NULL/nullptr/g` *.{h,cpp}
        </section>

        <section>
          <h2>C++14 has much more to offer!</h2>
          <ul>
            <li>static_assert (compile-time assertions)</li>
            <li>&lt;thread&gt;</li>
            <li>&lt;atomic&gt; (sane memory model)</li>
            <li>&lt;tuple&gt;</li>
            <li>variadic templates</li>
            <li>std::function</li>
            <li>move semantics (lets you make non-copyable types)</li>
            <li>override controls: override and final</li>
            <li>enum class (safer enum, at least a little)</li>
            <li>constant expressions: constexpr</li>
            <li>user-defined literals</li>
            <li>attributes like [[noreturn]]</li>
            <li>...</li>
          </ul>
        </section>

        <section>
          <h2>Pointers</h2>
          <p><a href="http://www.stroustrup.com/C++11FAQ.html">http://www.stroustrup.com/C++11FAQ.html</a></p>
          <p><a href="http://en.cppreference.com/w/">http://en.cppreference.com/w/</a></p>
          <p><img src="effmodc++.jpg" width="300" height="400" alt="Effective Modern C++ by Scott Meyers"/></p>
        </section>

      </div>

    </div>

    <script src="lib/js/head.min.js"></script>
    <script src="js/reveal.js"></script>

    <script>

      // Full list of configuration options available at:
      // https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({
        controls: true,
        progress: true,
        history: true,
        center: true,

        transition: 'slide', // none/fade/slide/convex/concave/zoom

        // Optional reveal.js plugins
        dependencies: [
          { src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
          { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'plugin/highlight/highlight.js', async: true, condition: function() { return !!document.querySelector( 'pre code' ); }, callback: function() { hljs.initHighlightingOnLoad(); } },
          { src: 'plugin/zoom-js/zoom.js', async: true },
          { src: 'plugin/notes/notes.js', async: true }
        ]
      });

    </script>

  </body>
</html>
